#!/usr/bin/perl
use strict;
#  Copyright (C) 2002 Adrian Ulrich <pab at blinkenlights.ch>
#  Part of the gnupod-tools collection
#
#  URL: http://www.blinkenlights.ch/cgi-bin/fm.pl?get=ipod
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# iTunes and iPod are trademarks of Apple
#
# This product is not supported/written/published by Apple!

use vars qw(@gnupod_db);

print "gnupod delete 0.1 (C) 2002 Adrian Ulrich\n";
print "Part of the gnupod-tools collection\n";
print "This tool helps you removing songs from your iPod\n\n";

if(!(-d $ARGV[0]))
{
  print "Error: iPod mountpoint\n $ARGV[0]\nis not a directory\n";
  print "Usage: gnupod_delete.pl iPod_MOUNTPOINT ID_TO_REMOVE..\n"; 
  exit(1);
}
elsif(! $ARGV[1])
{
 print "Error: no ID to remove\n";
 print "Usage: gnupod_delete.pl iPod_MOUNTPOINT ID_TO_REMOVE..\n"; 
}

stdtest();
cachedb();

for(my $j=1;$j!=int(@ARGV);$j++)
{
 kick($ARGV[$j]);
}

write_db();

print "..done!\nuse 'mktunes.pl' to update yor iTunesDB!\n";

sub write_db
{
my($i);
open(GPH, "> $ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") or die "Fatal: failed to write GNUtunesDB: $!\n";
 for($i=1;$i<=int(@gnupod_db);$i++)
  {
   print GPH "$gnupod_db[$i]\n" if ($gnupod_db[$i]);
  }
close(GPH);
}


sub cachedb
{
my($i, $count);
open(GPH, "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") or die "Could not open GNUtunesDB: $!\ndid you run 'gnupod_INITpod.pl' ?\n";
 while(defined($i = <GPH>)) #get old gnupod file
 {
 chomp($i);
   if($i && substr($i, 0, 1) ne "\#")
   { 
    $count++;    
    $gnupod_db[$count] = $i;
   }
 }
close(GPH);
}




sub kick
{
my($id, $fname, $desc, $foo);
($id) = @_;
($fname, undef, undef, undef, $desc) = split(/\t/, $gnupod_db[$id], 5);
if($fname)
  {
     $fname =~ tr/:/\//;
     $fname = $ARGV[0].$fname;
      print "Removing $fname ? [Y|N]\n";
      $foo = <STDIN>;
      chomp($foo);
      if($foo eq "y" || $foo eq "Y")
        {
         $gnupod_db[$id] = "";
          if(!unlink("$fname"))
          { print "!! Failed to remove $fname\n$!\n"; }
          else
          { print "- $fname\n";}
        }
   }
  else
   {
    print "Invalid id $id\n";
   }
}





sub stdtest
{
if(!(-w "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB"))
{
 print "Error: Cant write to your gnuPod-file\ndid you run 'gnupod_INITpod.pl' ?\n";
 exit(1);
}
if(!(-w "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: Cant write to your iTunesDB\ndid you run 'gnupod_INITpod.pl' ?\n";
 exit(1);
}

if ((-M "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") > (-M "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: your gnuPod-file is older than your iTunesDB! (Last update not done with gnuPod?)\n";
 print "Please run this comment to correct this problem:\n";
 print "tunes2pod.pl \$IPOD_MOUNTPOINT/iPod_Control/iTunes/iTunesDB > \$IPOD_MOUNTPOINT/iPod_Control/.gnupod/GNUtunesDB\n\n";
 print "This command will update your current gnuPodfile with the contents of your (newer) iTunesDB\n";
 exit(1);
}

return 0;
}
